const Main = imports.ui.main;
const St = imports.gi.St;
const UserMenu = imports.ui.userMenu;

function IMButton() {
    this._init.apply(this, arguments);
}

IMButton.prototype = {
	__proto__: UserMenu.UserMenuButton.prototype,
	
	_init: function() {
		let userMenu = Main.panel._statusArea['userMenu'];
		
		UserMenu.UserMenuButton.prototype._init.call(this, St.Align.START);
		this.actor.get_children()[0].get_children()[1].destroy();
		
		this._filter_IMMenu();
		this._filter_QBMenu();
		
		// Quit Button
		userMenu._quitIcon = new St.Icon({'icon-name': 'system-shutdown', 'icon-size':16});
		userMenu.actor.get_children()[0].add(userMenu._quitIcon);
		userMenu._iconBox.hide();
	},
	
	_filter_IMMenu: function() {
		let items = this.menu.box.get_children();
	
    		let i;
		for (i=0 ; i<items.length; i++)
		{
			let label = items[i]._delegate.label;
			if (label != undefined && label.get_text() == _("System Settings")) break;
		}
		for (; i<items.length; i++)
		{
			items[i].destroy();
		}
	},
	_filter_QBMenu: function() {
		let items = Main.panel._statusArea['userMenu'].menu.box.get_children();
		this.hiddenItems = new Array();
		
    		let i;
		for (i=0 ; i<items.length; i++)
		{
			let label = items[i]._delegate.label;
			if (label != undefined && label.get_text() == _("System Settings")) break;
			items[i].hide();
			this.hiddenItems.push(items[i]);
		}
	},
	cleanAllYouCan: function() {
		// unfilter QBMenu
		let i;
		for(i=0;i<this.hiddenItems.length;i++) { this.hiddenItems[i].show(); }
		
		// restore IM Icon
		Main.panel._statusArea['userMenu']._quitIcon.destroy();
		Main.panel._statusArea['userMenu']._iconBox.show();
	}
	
}

function init() {}

let _IMButton;

function enable() {
	_IMButton = new IMButton;
	
	let role = Main.panel._statusArea['userMenu'].actor._rolePosition;
	Main.panel._statusArea['userMenu'].actor._rolePosition = role + 1;
	
	Main.panel.addToStatusArea('social', _IMButton, role);
}

function disable() {
	_IMButton.cleanAllYouCan();
	_IMButton.destroy();
}
